// LAMPEGGI REAL TIME
//
// Esempio di programmazione "Real-Time"
// ovvero il microcontrollore esegue alcune operazioni
// in "contemporanea" (non è vero ma sembra)
// Non ci sono blocchi nel programma, per le temporizzazioni
// evitare di utilizzare SEMPRE le istruzioni delay()
//
// Corso AUTOMA-20 ITS 14/06/2021
//

// Definizione delle costanti
#define LED_VERDE   10
#define LED_ROSSO   13

#define TIME_VERDE_ON 	2000
#define TIME_VERDE_OFF  2000
#define TIME_ROSSO_ON 	 500
#define TIME_ROSSO_OFF   500

// Definizione delle variabili GLOBALI utilizzate dal programma
unsigned long TimeLedVerde;
int LedVerde;
unsigned long TimeLedRosso;
int LedRosso;

// ********************************************
// INIZIALIZZAZIONE DEL SISTEMA
// ********************************************
void setup()
{
  // Definizione dei pin di I/O
  pinMode(LED_VERDE, OUTPUT);
  pinMode(LED_ROSSO, OUTPUT);
  pinMode(LED_BLU, OUTPUT);
  // Accendo Led Verde con suo tempo di accensione
  TimeLedVerde = millis() + TIME_VERDE_ON;
  LedVerde = HIGH;
  digitalWrite( LED_VERDE, LedVerde );
  // Accendo Led Rosso con suo tempo di accensione
  TimeLedRosso = millis() + TIME_ROSSO_ON;
  LedRosso = HIGH;
  digitalWrite( LED_ROSSO, LedRosso );  
}

// ********************************************
// CICLO RIPETITIVO DEL PROGRAMMA UTENTE
// ********************************************
void loop()
{
  	// Gestione delle varie luci
	  GestioneLedVerde();
  	GestioneLedRosso();  
}

void GestioneLedVerde(void)
{
    // Gestione della temporizzazione del LED VERDE
	if( millis() >= TimeLedVerde )
    {
        if( LedVerde == HIGH )
        {
          LedVerde = LOW;
          TimeLedVerde = millis() + TIME_VERDE_OFF;
        }
        else
        {
          LedVerde = HIGH;
          TimeLedVerde = millis() + TIME_VERDE_ON;          
        }
    	digitalWrite( LED_VERDE, LedVerde );	        
    }  
}

void GestioneLedRosso(void)
{
  	// Gestione della temporizzazione del LED ROSSO
	if( millis() >= TimeLedRosso )
    {
        if( LedRosso == HIGH )
        {
          LedRosso = LOW;
          TimeLedRosso = millis() + TIME_ROSSO_OFF;
        }
        else
        {
          LedRosso = HIGH;
          TimeLedRosso = millis() + TIME_ROSSO_ON; 
        }
    	digitalWrite( LED_ROSSO, LedRosso );	        
    }    
}








